aboutsummaryrefslogtreecommitdiff
path: root/t/t1006-cat-file.sh
diff options
context:
space:
mode:
authorPatrick Steinhardt <ps@pks.im>2025-04-02 13:13:40 +0200
committerJunio C Hamano <gitster@pobox.com>2025-04-07 14:43:50 -0700
commitdbe1b32d59699092d549150e2db7af07e3cbfaf3 (patch)
treeeeff6083d28695e8d7ede13e3e4d91184043e8c5 /t/t1006-cat-file.sh
parent3794e9bf982cde754a48b569a639bd2e180e754c (diff)
downloadgit-dbe1b32d59699092d549150e2db7af07e3cbfaf3.tar.xz
builtin/cat-file: support "blob:limit=" objects filter
Implement support for the "blob:limit=" filter in git-cat-file(1), which causes us to omit all blobs that are bigger than a certain size. Signed-off-by: Patrick Steinhardt <ps@pks.im> Signed-off-by: Junio C Hamano <gitster@pobox.com>
Diffstat (limited to 't/t1006-cat-file.sh')
-rwxr-xr-xt/t1006-cat-file.sh18
1 files changed, 15 insertions, 3 deletions
diff --git a/t/t1006-cat-file.sh b/t/t1006-cat-file.sh
index 7404c135b1..4f14840b71 100755
--- a/t/t1006-cat-file.sh
+++ b/t/t1006-cat-file.sh
@@ -1356,11 +1356,12 @@ test_expect_success PERL '--batch-command info is unbuffered by default' '
test_expect_success 'setup for objects filter' '
git init repo &&
(
- # Seed the repository with three different sets of objects:
+ # Seed the repository with four different sets of objects:
#
# - The first set is fully packed and has a bitmap.
# - The second set is packed, but has no bitmap.
# - The third set is loose.
+ # - The fourth set is loose and contains big objects.
#
# This ensures that we cover all these types as expected.
cd repo &&
@@ -1368,7 +1369,14 @@ test_expect_success 'setup for objects filter' '
git repack -Adb &&
test_commit second &&
git repack -d &&
- test_commit third
+ test_commit third &&
+
+ for n in 1000 10000
+ do
+ printf "%"$n"s" X >large.$n || return 1
+ done &&
+ git add large.* &&
+ git commit -m fourth
)
'
@@ -1380,7 +1388,7 @@ test_expect_success 'objects filter with unknown option' '
test_cmp expect err
'
-for option in blob:limit=1 object:type=tag sparse:oid=1234 tree:1 sparse:path=x
+for option in object:type=tag sparse:oid=1234 tree:1 sparse:path=x
do
test_expect_success "objects filter with unsupported option $option" '
case "$option" in
@@ -1435,5 +1443,9 @@ test_objects_filter () {
}
test_objects_filter "blob:none"
+test_objects_filter "blob:limit=1"
+test_objects_filter "blob:limit=500"
+test_objects_filter "blob:limit=1000"
+test_objects_filter "blob:limit=1k"
test_done